=== debian/watch ===
# to be processed with uscan(1)
version=3
https://puredata.info/downloads/syslog/releases/(\d\.\d)/syslog-(.+)\.tar.gz
